"use strict";

this.name            = "whichcat";
this.author          = "Commander McLane, Superbat Prime, v4hn";
this.copyright       = "CC-by-nc-sa 3.0";
this.description     = "script for making various ships cats available for purchase";
this.version         = "1.1";

// probability that a cat is available in a station
// keep in mind that even if a cat is available,
// it might not be available to _you_ because of the cat's preferences
this._catProbability = 0.3;

// So the average cat will die the ninth time it's shot :-)
this._catDiesProbability = 0.11;


this._countCats= function()
{
    var i= 0;
    while(EquipmentInfo.infoForKey("EQ_SHIPS_CAT_" + (i+1).toString()))
        ++i;
    this._number_of_cats= i;
}
// count cats once when loading the oxp
this._countCats()


// load/save currently available cat
this.startUp= function()
{
    this._cat= missionVariables.whichcat_cat;
    if(!this._cat || this._cat <= 0 || this._cat > this._number_of_cats){
        this._drawRandomCat()
    }
}
this.playerWillSaveGame= function()
{
    missionVariables.whichcat_cat= this._cat;
}


this._drawRandomCat= function()
{
    var choice= Math.ceil(Math.random() * (this._number_of_cats / this._catProbability) );

    // either a valid cat or none(i.e. _number_of_cats+1)
    this._cat= Math.min( choice, this._number_of_cats+1 );

    // make this._cat available and disable all others
    var i= 1;
    var catit;
    while( catit= EquipmentInfo.infoForKey("EQ_SHIPS_CAT_" + i.toString()) ){
        if( i == this._cat )
            catit.effectiveTechLevel= 0;
        else
            catit.effectiveTechLevel= null;
        ++i;
    }
}

// whenever the player docks, a new cat might become available
this.shipDockedWithStation= function(station)
{
    this._drawRandomCat();
}


this.equipmentDamaged= function(equipment)
{
    if(typeof equipment === "string"){
        equipment= EquipmentInfo.infoForKey(equipment)
    }

    if( equipment.equipmentKey.indexOf("EQ_SHIPS_CAT_") != 0 ){
        return;
    }

    if(player.ship.equipmentStatus(equipment) !== "EQUIPMENT_UNAVAILABLE" && player.ship.equipmentStatus(equipment) !== "EQUIPMENT_DAMAGED"){
        return;
    }

    if( Math.random() < this._catDiesProbability ){
        player.ship.removeEquipment(equipment);
        // remove "Ship's Cat/Dog: " prefix
        var cats_name= equipment.name.substr(equipment.name.indexOf(":")+1).trim();
        player.consoleMessage(cats_name + " has been killed!");
    }
}
